YANG Groupings for QUIC clients and QUIC servers
Internet-Draft draft-andersson-netconf-quic-client-server-01
Per Andersson
Cisco Systems
per.ietf@ionio.se
OPS Area
NETCONF Working Group
This document defines two YANG 1.1 modules to support the configuration of QUIC clients and QUIC servers. The modules include basic parameters for configuring QUIC based clients and servers.
Editorial note (To be removed by the RFC Editor)
This draft contains placeholder values that need to be replaced with finalized values at the time of publication. This note summarizes all of the substitutions that are needed. No other RFC Editor instructions are specified elsewhere in this document.
Artwork in this document contains shorthand references to drafts in progress. Please apply the following replacements:
- AAAA --> the assigned RFC value for this draft
- CCCC --> the assigned RFC value for draft-ietf-netconf-udp-client-server
- HHHH --> the assigned RFC value for draft-ietf-netconf-netconf-client-server
Introduction
This documents defines two YANG 1.1 [RFC7950] modules to support the configuration of QUIC clients and QUIC servers (QUIC is defined in [RFC9000]), either as standalone or in conjunction with configuration of other protocol layers.
Terminology
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
The following terms are defined in [RFC7950] and are not redefined here: client, data model, data tree, feature, extension, module, leaf, leaf-list, and server.
The "ietf-quic-client" Module
This section defines a YANG 1.1 module called "ietf-quic-client".
Data model overview
This section presents an overview of of the "ietf-quic-client" module in terms of features and groupings.
Features
The module itself does not define any features. However, in order to require TLS 1.3 the following "if-feature" is defined "tlscmn:tls13 not tlscmn:tls12". For QUIC TLS requirements see [RFC9001].
For further details about available features see the "ietf-tls-client" and "ietf-udp-client" modules. defined in [RFC9645] and [I-D.ietf-netconf-udp-client-server] respectively.
Groupings
The "ietf-quic-client" module defines the following "grouping" statement:
- quic-client
This grouping is presented in the following subsection.
The "quic-client" Grouping
The following tree diagram [RFC8340] illustrates the "quic-client" grouping:

  grouping quic-client:
    +---u tlsc:tls-client-grouping
    |       {tlscmn:tls13 and not tlscmn:tls12}?
    +---u udpc:udp-client

Comments:
- This grouping uses the "tls-client-grouping" grouping discussed in [RFC9645]. Note that QUIC requires TLS 1.3 (or later), thus the "if-feature" invariant "tlscmn:tls13 and not tlscmn:tls12" is defined for this grouping.
- This grouping uses the "udp-client-grouping" grouping discussed in [I-D.ietf-netconf-udp-client-server].
The "quic-client" Augments
The "ietf-quic-client" module augments the "/ncs:netconf-client/ncs:initiate" container [I-D.ietf-netconf-netconf-client-server] with the "if-feature" "quic-initiate".
This augment enables configuration of QUIC-level parameters for NETCONF client connections.
The following tree diagram [RFC8340] illustrates the "quic-client" augmentation of "netconf-client":

  augment /ncc:netconf-client/ncc:initiate:
  augment /ncc:netconf-client/ncc:initiate/ncc:netconf-server
            /ncc:endpoints/ncc:endpoint/ncc:transport:
    +--:(quic) {quic-initiate}?
       +--rw quic
          +---u quicc:quic-client

YANG Module
This YANG module has normative references to [RFC9645] and [I-D.ietf-netconf-udp-client-server].
<CODE BEGINS> file "ietf-quic-client@2024-10-19.yang"

module ietf-quic-client {
  yang-version 1.1;
  namespace
    "urn:ietf:params:xml:ns:yang:ietf-quic-client";
  prefix quicc;

  import ietf-netconf-client {
    prefix ncc;
    reference
      "RFC HHHH: NETCONF Client and Server Models";
  }

  import ietf-tls-client {
    prefix tlsc;
    reference
      "RFC 9645: YANG Groupings for TLS Clients and TLS Servers";
  }

  import ietf-tls-common {
    prefix tlscmn;
    reference
      "RFC 9645: YANG Groupings for TLS Clients and TLS Servers";
  }

  import ietf-udp-client {
    prefix udpc;
    reference
      "RFC CCCC: YANG Groupings for UDP Clients and UDP Servers";
  }

  organization
    "IETF NETCONF (Network Configuration) Working Group";

  contact
    "WG List: NETCONF WG list <mailto:netconf@ietf.org>
     WG Web:  https://datatracker.ietf.org/wg/netconf
     Author:  Per Andersson <mailto:per.ietf@ionio.se>";

  description
    "This module defines reusable groupings for QUIC clients that
     can be used as a basis for specific QUIC client instances.

     Copyright (c) 2024 IETF Trust and the persons identified
     as authors of the code. All rights reserved.

     Redistribution and use in source and binary forms, with
     or without modification, is permitted pursuant to, and
     subject to the license terms contained in, the Revised
     BSD License set forth in Section 4.c of the IETF Trust's
     Legal Provisions Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC AAAA
     (https://www.rfc-editor.org/info/rfcAAAA); see the RFC
     itself for full legal notices.

     The key words 'MUST', 'MUST NOT', 'REQUIRED', 'SHALL',
     'SHALL NOT', 'SHOULD', 'SHOULD NOT', 'RECOMMENDED',
     'NOT RECOMMENDED', 'MAY', and 'OPTIONAL' in this document
     are to be interpreted as described in BCP 14 (RFC 2119)
     (RFC 8174) when, and only when, they appear in all
     capitals, as shown here.";

  revision 2024-10-19 {
    description
      "Initial version";
    reference
      "RFC AAAA: YANG Groupings for QUIC Clients and QUIC Servers";
  }

  // Features

  feature quic-initiate {
    description
      "The 'quic-initiate' feature indicates that the NETCONF client
       supports initiating QUIC connections to NETCONF servers.";
    reference
      "RFC AAAA: YANG Groupings for QUIC Clients and QUIC Servers";
  }

  /*
  FIXME
  feature quic-listen {
    description
      "The 'quic-listen' feature indicates that the NETCONF client
       supports opening a port to listen for incoming NETCONF
       server call-home QUIC connections.";
    reference
      "RFC 8071: NETCONF Call Home and RESTCONF Call Home";
    reference
      "RFC AAAA: YANG Groupings for QUIC Clients and QUIC Servers";
  }
  */

  // Groupings

  grouping quic-client {
    description
      "Grouping to configure a QUIC client.";
    reference
      "RFC 9000: QUIC: A UDP-Based Multiplexed and Secure Transport";

    uses tlsc:tls-client-grouping {
      if-feature "tlscmn:tls13 and not tlscmn:tls12";
      description
        "QUIC requires that TLS 1.3 (or later) is used.";
      reference
        "RFC 9001: Using TLS to Secure QUIC";
    }
    uses udpc:udp-client;
  }

  // Augments

  /* FIXME seems pyang don't support this augment */
  augment "/ncc:netconf-client/ncc:initiate" {
    if-feature "quic-initiate";
    description
      "Add 'quic-initate' feature to the NETCONF client connection
       configuration.";
  }

  augment "/ncc:netconf-client/ncc:initiate/ncc:netconf-server" +
          "/ncc:endpoints/ncc:endpoint/ncc:transport" {
    description
      "Add QUIC transport to the NETCONF client connection
       configuration";
    case quic {
      if-feature "quic-initiate";
      container quic {
        description
          "QUIC-level client parameters to initiate a NETCONF over
           QUIC connection.";
        uses quicc:quic-client;
      }
    }
  }
}

<CODE ENDS>
The "ietf-quic-server" Module
This section defines a YANG 1.1 module called "ietf-quic-server".
Data model overview
This section presents an overview of of the "ietf-quic-server" module in terms of features and groupings.
Features
The module itself does not define any features. However, in order to require TLS 1.3 the following "if-feature" is defined "tlscmn:tls13 not tlscmn:tls12". For QUIC TLS requirements see [RFC9001].
For further details about available features see the "ietf-tls-server" and "ietf-udp-server" modules, defined in [RFC9645] and [I-D.ietf-netconf-udp-client-server] respectively.
Groupings
The "ietf-quic-server" module defines the following "grouping" statement:
- quic-server
This grouping is presented in the following subsection.
The "quic-server" Grouping
The following tree diagram [RFC8340] illustrates the "quic-server" grouping:

  grouping quic-server:
    +---u tlss:tls-server-grouping
    |       {tlscmn:tls13 and not tlscmn:tls12}?
    +---u udps:udp-server

Comments:
- This grouping uses the "tls-server-grouping" grouping discussed in [RFC9645]. Note that QUIC requires TLS 1.3 (or later), thus the "if-feature" invariant "tlscmn:tls13 and not tlscmn:tls12" is defined for this grouping.
- This grouping uses the "udp-server-grouping" grouping discussed in [I-D.ietf-netconf-udp-client-server].
The "quic-server" Augments
The "ietf-quic-server" module augments the "/ncs:netconf-server/ncs:listen" container [I-D.ietf-netconf-netconf-client-server] with the "if-feature" "quic-listen".
This augment enables configuration of QUIC-level parameters for NETCONF server connections.
The following tree diagram [RFC8340] illustrates the "quic-server" augmentation of "netconf-server":

  augment /ncs:netconf-server/ncs:listen:
  augment /ncs:netconf-server/ncs:listen/ncs:endpoints/ncs:endpoint
            /ncs:transport:
    +--:(quic) {quic-listen}?
       +--rw quic
          +---u quics:quic-server

YANG Module
This YANG module has normative references to [RFC9645] and [I-D.ietf-netconf-udp-client-server].
<CODE BEGINS> file "ietf-quic-server@2024-10-19.yang"

module ietf-quic-server {
  yang-version 1.1;
  namespace
    "urn:ietf:params:xml:ns:yang:ietf-quic-server";
  prefix quics;

  import ietf-netconf-server {
    prefix ncs;
    reference
      "RFC HHHH: NETCONF Client and Server Models";
  }

  import ietf-tls-server {
    prefix tlss;
    reference
      "RFC 9645: YANG Groupings for TLS Clients and TLS Servers";
  }

  import ietf-tls-common {
    prefix tlscmn;
    reference
      "RFC 9645: YANG Groupings for TLS Clients and TLS Servers";
  }

  import ietf-udp-server {
    prefix udps;
    reference
      "RFC CCCC: YANG Groupings for UDP Clients and UDP Servers";
  }

  organization
    "IETF NETCONF (Network Configuration) Working Group";

  contact
    "WG List: NETCONF WG list <mailto:netconf@ietf.org>
     WG Web:  https://datatracker.ietf.org/wg/netconf
     Author:  Per Andersson <mailto:per.ietf@ionio.se>";

  description
    "This module defines reusable groupings for QUIC servers that
     can be used as a basis for specific QUIC server instances.

     Copyright (c) 2024 IETF Trust and the persons identified
     as authors of the code. All rights reserved.

     Redistribution and use in source and binary forms, with
     or without modification, is permitted pursuant to, and
     subject to the license terms contained in, the Revised
     BSD License set forth in Section 4.c of the IETF Trust's
     Legal Provisions Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC AAAA
     (https://www.rfc-editor.org/info/rfcAAAA); see the RFC
     itself for full legal notices.

     The key words 'MUST', 'MUST NOT', 'REQUIRED', 'SHALL',
     'SHALL NOT', 'SHOULD', 'SHOULD NOT', 'RECOMMENDED',
     'NOT RECOMMENDED', 'MAY', and 'OPTIONAL' in this document
     are to be interpreted as described in BCP 14 (RFC 2119)
     (RFC 8174) when, and only when, they appear in all
     capitals, as shown here.";

  revision 2024-10-19 {
    description
      "Initial version";
    reference
      "RFC AAAA: YANG Groupings for QUIC Clients and QUIC Servers";
  }

  // Features

  feature quic-listen {
    description
      "The 'quic-listen' feature indicates that the NETCONF server
       supports the QUIC transport.";
    reference
      "I-D.draft-ietf-netconf-over-quic-00: NETCONF over QUIC";
  }

  // FIXME feature quic-call-home

  // Groupings

  grouping quic-server {
    description
      "Grouping to configure a QUIC server.";
    reference
      "RFC 9000: QUIC: A UDP-Based Multiplexed and Secure Transport";

    uses tlss:tls-server-grouping {
      if-feature "tlscmn:tls13 and not tlscmn:tls12";
      description
        "QUIC requires that TLS 1.3 (or later) is used.";
      reference
        "RFC 9001: Using TLS to Secure QUIC";
    }
    uses udps:udp-server;
  }

  // Augments

  /* FIXME seems pyang don't support this augment */
  augment "/ncs:netconf-server/ncs:listen" {
    if-feature "quic-listen";
    description
      "Add 'quic-listen' feature to the NETCONF server listen
       configuration.";
  }

  augment "/ncs:netconf-server/ncs:listen/ncs:endpoints" +
          "/ncs:endpoint/ncs:transport" {
    description
      "Add QUIC transport to the NETCONF server listen
       configuration.";
    case quic {
      if-feature "quic-listen";
      container quic {
        description
          "QUIC-level server parameters to listen for NETCONF over
           QUIC connections.";
        uses quics:quic-server;
      }
    }
  }
}

<CODE ENDS>
Security Considerations
This section follows the template defined in Section 3.7.1 of [RFC8407].
The YANG modules specified in this document defines a schema for data that is designed to be accessed via network management protocols such as NETCONF [RFC6241] or RESTCONF [RFC8040]. The lowest NETCONF layer is the secure transport layer, and the mandatory-to-implement secure transport is Secure Shell (SSH) [RFC6242]. The lowest RESTCONF layer is HTTPS, and the mandatory-to-implement secure transport is TLS [RFC8446].
The Network Configuration Access Control Model (NACM) [RFC8341] provides the means to restrict access for particular NETCONF or RESTCONF users to a preconfigured subset of all available NETCONF or RESTCONF protocol operations and content.
The modules presented in this draft does not contain any protocol accessible nodes, and thus the security considerations for such are not provided here.
Furthermore, the modules defines groupings, these considerations are primarily for the designers of other modules that use these groupings.
Security considerations for the groupings used in the modules are discussed in [RFC9645] and [I-D.ietf-netconf-udp-client-server], refer to these documents for further details.
Since the modules does not define any RPCs or actions or notifications, and thus the security considerations for such are not provided here.
IANA Considerations
The "IETF XML" Registry
This document registers two URIs in the "ns" subregistry of the IETF XML Registry [RFC3688] maintained at https://www.iana.org/assignments/xml-registry/xml-registry.xhtml#ns. Following the format in [RFC3688], the following registration is requested:

URI: urn:ietf:params:xml:ns:yang:ietf-quic-client
Registrant Contact: The IESG.
XML: N/A, the requested URI is an XML namespace.

URI: urn:ietf:params:xml:ns:yang:ietf-quic-server
Registrant Contact: The IESG.
XML: N/A, the requested URI is an XML namespace.

The "YANG Module Names" Registry
This document registers two YANG modules in the YANG Module Names registry [RFC6020] maintained at https://www.iana.org/assignments/yang-parameters/yang-parameters.xhtml. Following the format defined in [RFC6020], the below registration is requested:

name: ietf-quic-client
namespace: urn:ietf:params:xml:ns:yang:ietf-quic-client
prefix: quicc
RFC: AAAA

name: ietf-quic-server
namespace: urn:ietf:params:xml:ns:yang:ietf-quic-server
prefix: quics
RFC: AAAA

References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC3688]

The IETF XML Registry
M. Mealling
January 2004
BCP 81
RFC 3688
DOI 10.17487/RFC3688
[RFC6241]

Network Configuration Protocol (NETCONF)
R. Enns, Ed.
M. Bjorklund, Ed.
J. Schoenwaelder, Ed.
A. Bierman, Ed.
June 2011
RFC 6241
DOI 10.17487/RFC6241
[RFC6242]

Using the NETCONF Protocol over Secure Shell (SSH)
M. Wasserman
June 2011
RFC 6242
DOI 10.17487/RFC6242
[RFC7950]

The YANG 1.1 Data Modeling Language
M. Bjorklund, Ed.
August 2016
RFC 7950
DOI 10.17487/RFC7950
[RFC8040]

RESTCONF Protocol
A. Bierman
M. Bjorklund
K. Watsen
January 2017
RFC 8040
DOI 10.17487/RFC8040
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC8341]

Network Configuration Access Control Model
A. Bierman
M. Bjorklund
March 2018
STD 91
RFC 8341
DOI 10.17487/RFC8341
[RFC8407]

Guidelines for Authors and Reviewers of Documents Containing YANG Data Models
A. Bierman
October 2018
BCP 216
RFC 8407
DOI 10.17487/RFC8407
[RFC8446]

The Transport Layer Security (TLS) Protocol Version 1.3
E. Rescorla
August 2018
RFC 8446
DOI 10.17487/RFC8446
[RFC9000]

QUIC: A UDP-Based Multiplexed and Secure Transport
J. Iyengar, Ed.
M. Thomson, Ed.
May 2021
RFC 9000
DOI 10.17487/RFC9000
[RFC9001]

Using TLS to Secure QUIC
M. Thomson, Ed.
S. Turner, Ed.
May 2021
RFC 9001
DOI 10.17487/RFC9001
[RFC9645]

YANG Groupings for TLS Clients and TLS Servers
K. Watsen
October 2024
RFC 9645
DOI 10.17487/RFC9645
Informative References
[RFC6020]

YANG - A Data Modeling Language for the Network Configuration Protocol (NETCONF)
M. Bjorklund, Ed.
October 2010
RFC 6020
DOI 10.17487/RFC6020
[RFC8340]

YANG Tree Diagrams
M. Bjorklund
L. Berger, Ed.
March 2018
BCP 215
RFC 8340
DOI 10.17487/RFC8340
[I-D.ietf-netconf-udp-client-server]
[I-D.ietf-netconf-netconf-client-server]